const { format } = require("winston");

module.exports = function(source) {
	return format.combine(
		format.json(),
		format.printf(info => {
			const json_log = {
				timestamp: new Date().toISOString(),
				level: info.level,
				source: `${source.toUpperCase()}.${process.pid}`,
				message: info.message
			};
			return JSON.stringify(json_log);
		})
	);
};
